﻿#include "MeshLoader.h"
#include "AneuMeshLoader.h"
#include "Exceptions.h"

#include <iostream>
#include <string>
#include <fstream>
#include <algorithm>


//!!! Задание на защиту (не удалять!)
//!!! Реализовать на основе ranges.
//!!! 1. Отсортировать все тетраэдры по значению минимального двугранного угла между гранями.
//!!! 2. Вывести списки ID узлов КЭ с 10 по 20 в полученном контенейре в файл с помощью потокового итрератора.


int main() {
    const std::string FILEPATH = "..tests/test.aneu";
    MeshLoader* loader = new AneuMeshLoader;
    std::vector<FiniteElement> elems;
    std::vector<Node> nodes;
    std::vector<std::vector<Node>> neighbors;
    std::vector<BoundaryFiniteElement> surfaces;

    loader->LoadMesh(FILEPATH);

    std::cout << "PrintData test:" << std::endl;
    loader->PrintData();

    std::cout << "FiniteElementsByThreeId test:" << std::endl;
    elems = loader->FiniteElementsByThreeId(1, 2, 3);
    std::cout << elems << std::endl;
    elems.clear();

    std::cout << "FiniteElementsByRib" << std::endl;
    elems = loader->FiniteElementsByRib(1, 2);
    std::cout << elems << std::endl;
    elems.clear();

    std::cout << "VertexNodesBySurfaceId test" << std::endl;
    nodes = loader->VertexNodesBySurfaceId(1);
    std::cout << nodes << std::endl;
    nodes.clear();

    std::cout << "FiniteElementsByMaterialId test" << std::endl;
    elems = loader->FiniteElementsByMaterialId(1);
    std::cout << elems << std::endl;
    elems.clear();

    std::cout << "BoundaryFiniteElementsById test" << std::endl;
    surfaces = loader->BoundaryFiniteElementsById(1);
    std::cout << surfaces;
    surfaces.clear();

    std::cout << "NodesNeighbors test" << std::endl;
    neighbors = loader->NodesNeighbors();
    for (int i = 1; i < neighbors.size(); ++i) {
        std::cout << i << "    " << neighbors[i] << std::endl;
    }
    neighbors.clear();

    std::cout << "TransformElementsToQuadr test" << std::endl;
    loader->TransformElementsToQuadr();
    loader->PrintData();

    delete loader;
    return 0;
}